=== modified file 'doc/extension_system.txt'
--- doc/extension_system.txt	2015-03-08 16:10:20 +0000
+++ doc/extension_system.txt	2016-03-12 20:11:31 +0000
@@ -321,7 +321,7 @@
 users will never need to write this type of extension, they are pretty
 much for Inkscape core developers only.
 
-=== Writeing Your Extension ===
+=== Writing Your Extension ===
 
 This section provides some guidance and examples for implementing
 different kinds of Extensions.
@@ -334,7 +334,7 @@
 
 === Creating an INX File ===
 
-Every extension must have a corrosponding *.inx file.  This is an XML
+Every extension must have a corresponding *.inx file.  This is an XML
 file that provides Inkscape with information about the module and allows
 it to load the info without needing to access the module itself.  The
 *.inx file contains enough info for Inkscape to set up menu items and
@@ -342,7 +342,7 @@
 
 === Packaging Your Extension ===
 
-=== Contributing Your Extensino to the Inkscape Community ===
+=== Contributing Your Extension to the Inkscape Community ===
 
 Once your extension is complete, you may wish to share it with the
 community.  There are of course no hard and fast rules for how to share

=== modified file 'src/extension/implementation/implementation.h'
--- src/extension/implementation/implementation.h	2015-04-27 23:39:29 +0000
+++ src/extension/implementation/implementation.h	2016-03-12 20:22:48 +0000
@@ -18,7 +18,7 @@
 #include <2geom/forward.h>
 
 namespace Gtk {
-	class Widget;
+    class Widget;
 }
 
 class SPDocument;
@@ -33,7 +33,7 @@
 } // namespace UI
 
 namespace XML {
-	class Node;
+    class Node;
 } // namespace XML
 
 namespace Extension {
@@ -51,10 +51,10 @@
  */
 class ImplementationDocumentCache {
 
-	/**
+    /**
          * The document that this instance is working on.
          */
-	Inkscape::UI::View::View * _view;
+    Inkscape::UI::View::View * _view;
 public:
 	ImplementationDocumentCache (Inkscape::UI::View::View * view) :
 			_view(view)
@@ -116,7 +116,7 @@
     // ----- Effect functions -----
     /** Find out information about the file. */
     virtual Gtk::Widget * prefs_effect(Inkscape::Extension::Effect *module,
-	                               Inkscape::UI::View::View *view,
+                                       Inkscape::UI::View::View *view,
                                        sigc::signal<void> *changeSignal,
                                        ImplementationDocumentCache *docCache);
     virtual void effect(Inkscape::Extension::Effect * /*module*/,

=== modified file 'src/extension/implementation/script.cpp'
--- src/extension/implementation/script.cpp	2016-02-09 02:13:32 +0000
+++ src/extension/implementation/script.cpp	2016-03-12 20:22:48 +0000
@@ -152,7 +152,7 @@
 }
 
 /**
- *   brief     Destructor
+ *   \brief     Destructor
  */
 Script::~Script()
 {
@@ -280,9 +280,9 @@
 
 /**
     \return   none
-    \brief    This function 'loads' an extention, basically it determines
-              the full command for the extention and stores that.
-    \param    module  The extention to be loaded.
+    \brief    This function 'loads' an extension, basically it determines
+              the full command for the extension and stores that.
+    \param    module  The extension to be loaded.
 
     The most difficult part about this function is finding the actual
     command through all of the Reprs.  Basically it is hidden down a
@@ -292,7 +292,7 @@
 
     At that point all of the loops are exited, and there is an
     if statement to make sure they didn't exit because of not finding
-    the command.  If that's the case, the extention doesn't get loaded
+    the command.  If that's the case, the extension doesn't get loaded
     and should error out at a higher level.
 */
 
@@ -545,17 +545,17 @@
 
 /**
     \return   none
-    \brief    This function uses an extention to save a document.  It first
+    \brief    This function uses an extension to save a document.  It first
               creates an SVG file of the document, and then runs it through
               the script.
-    \param    module    Extention to be used
+    \param    module    Extension to be used
     \param    doc       Document to be saved
     \param    filename  The name to save the final file as
     \return   false in case of any failure writing the file, otherwise true
 
     Well, at some point people need to save - it is really what makes
     the entire application useful.  And, it is possible that someone
-    would want to use an extetion for this, so we need a function to
+    would want to use an extension for this, so we need a function to
     do that eh?
 
     First things first, the document is saved to a temporary file that
@@ -563,7 +563,7 @@
     ink_ext_ as a prefix.  Don't worry, this file gets deleted at the
     end of the function.
 
-    After we have the SVG file, then extention_execute is called with
+    After we have the SVG file, then Script::execute is called with
     the temporary file name and the final output filename.  This should
     put the output of the script into the final output file.  We then
     delete the temporary file.
@@ -612,7 +612,7 @@
     // FIXME: convert to utf8 (from "filename encoding") and unlink_utf8name
     unlink(tempfilename_in.c_str());
 
-    if (success == false) {
+    if (!success) {
         throw Inkscape::Extension::Output::save_failed();
     }
 
@@ -623,8 +623,8 @@
 
 /**
     \return    none
-    \brief     This function uses an extention as a effect on a document.
-    \param     module   Extention to effect with.
+    \brief     This function uses an extension as a effect on a document.
+    \param     module   Extension to effect with.
     \param     doc      Document to run through the effect.
 
     This function is a little bit trickier than the previous two.  It
@@ -711,7 +711,7 @@
         }
     }
     
-    if(tool){
+    if(tool) {
         Inkscape::UI::ControlPointSelection *cps = tool->_selected_nodes;
         for (Inkscape::UI::ControlPointSelection::iterator i = cps->begin(); i != cps->end(); ++i) {
             Inkscape::UI::Node *node = dynamic_cast<Inkscape::UI::Node*>(*i);

=== modified file 'src/extension/init.cpp'
--- src/extension/init.cpp	2014-06-26 19:40:39 +0000
+++ src/extension/init.cpp	2016-03-12 20:11:31 +0000
@@ -1,6 +1,6 @@
 /*
  * This is what gets executed to initialize all of the modules.  For
- * the internal modules this invovles executing their initialization
+ * the internal modules this involves executing their initialization
  * functions, for external ones it involves reading their .spmodule
  * files and bringing them into Sodipodi.
  *