=== modified file 'share/icons/icons.svg'
--- share/icons/icons.svg	2013-06-15 21:18:59 +0000
+++ share/icons/icons.svg	2013-09-09 08:50:32 +0000
@@ -3512,6 +3512,38 @@
 </g>
 <rect y="363" x="593" height="3" width="3" id="rect6096" style="fill:#ff7777;fill-opacity:1;fill-rule:evenodd;stroke:#ff0000;stroke-width:0.99999952;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:0;stroke-opacity:0.94117647;stroke-dasharray:none;stroke-dashoffset:0;marker:none;display:inline" />
 </g>
+<g id="connector-straight" style="fill:none;stroke-linecap:round;stroke-opacity:0.8">
+  <rect y="361" x="597" height="11" width="11" style="fill:none" />
+  <path style="stroke:#3c3c3c" d="m 599.5,363.5 6,6" sodipodi:nodetypes="cc" />
+  <path style="stroke:#000000" d="m 599.5,362.5 a 1,1 0 1 1 -2,0 1,1 0 1 1 2,0 z" sodipodi:type="arc" sodipodi:cx="598.5" sodipodi:cy="362.5" sodipodi:rx="1" sodipodi:ry="1" />
+  <path style="stroke:#000000" d="m 607.5,370.5 a 1,1 0 1 1 -2,0 1,1 0 1 1 2,0 z" sodipodi:type="arc" sodipodi:cx="606.5" sodipodi:cy="370.5" sodipodi:rx="1" sodipodi:ry="1" />
+</g>
+<g id="connector-avoid-orthogonal" style="fill:none;stroke-linecap:round;stroke-opacity:0.8">
+  <rect y="361" x="610" height="11" width="11" style="fill:none" />
+  <path style="stroke:#3c3c3c" d="m 612.5,362.5 7,0 0,7" sodipodi:nodetypes="ccc" />
+  <path style="stroke:#000000" d="m 612.5,362.5 a 1,1 0 1 1 -2,0 1,1 0 1 1 2,0 z" sodipodi:type="arc" sodipodi:cx="611.5" sodipodi:cy="362.5" sodipodi:rx="1" sodipodi:ry="1" />
+  <path style="stroke:#000000" d="m 620.5,370.5 a 1,1 0 1 1 -2,0 1,1 0 1 1 2,0 z" sodipodi:type="arc" sodipodi:cx="619.5" sodipodi:cy="370.5" sodipodi:rx="1" sodipodi:ry="1" />
+  <rect y="366.5" x="611.5" height="4" width="5" style="fill:#b3b3b3;stroke:#3c3c3c" />
+</g>
+<g id="connector-avoid-polyline" style="fill:none;stroke-linecap:round;stroke-opacity:0.8">
+  <rect y="361" x="623" height="11" width="11" style="fill:none" />
+  <path style="stroke:#3c3c3c" d="m 625.5,362.5 5,2 2,5" sodipodi:nodetypes="ccc" />
+  <path style="stroke:#000000" d="m 625.5,362.5 a 1,1 0 1 1 -2,0 1,1 0 1 1 2,0 z" sodipodi:type="arc" sodipodi:cx="624.5" sodipodi:cy="362.5" sodipodi:rx="1" sodipodi:ry="1" />
+  <path style="stroke:#000000" d="m 633.5,370.5 a 1,1 0 1 1 -2,0 1,1 0 1 1 2,0 z" sodipodi:type="arc" sodipodi:cx="632.5" sodipodi:cy="370.5" sodipodi:rx="1" sodipodi:ry="1" />
+  <rect y="366.5" x="624.5" height="4" width="5" style="fill:#b3b3b3;stroke:#3c3c3c" />
+</g>
+<g id="connector-orthogonal-horizontal" style="fill:none;stroke-linecap:round;stroke-opacity:0.8">
+  <rect y="361" x="636" height="11" width="11" style="fill:none" />
+  <path style="stroke:#3c3c3c" d="m 638.5,362.5 7,0 0,7" sodipodi:nodetypes="ccc" />
+  <path style="stroke:#000000" d="m 638.5,362.5 a 1,1 0 1 1 -2,0 1,1 0 1 1 2,0 z" sodipodi:type="arc" sodipodi:cx="637.5" sodipodi:cy="362.5" sodipodi:rx="1" sodipodi:ry="1" />
+  <path style="stroke:#000000" d="m 646.5,370.5 a 1,1 0 1 1 -2,0 1,1 0 1 1 2,0 z" sodipodi:type="arc" sodipodi:cx="645.5" sodipodi:cy="370.5" sodipodi:rx="1" sodipodi:ry="1" />
+</g>
+<g id="connector-orthogonal-vertical" style="fill:none;stroke-linecap:round;stroke-opacity:0.8">
+  <rect y="361" x="649" height="11" width="11" style="fill:none" />
+  <path style="stroke:#3c3c3c" d="m 650.5,363.5 0,7 7,0" sodipodi:nodetypes="ccc" />
+  <path style="stroke:#000000" d="m 651.5,362.5 a 1,1 0 1 1 -2,0 1,1 0 1 1 2,0 z" sodipodi:type="arc" sodipodi:cx="650.5" sodipodi:cy="362.5" sodipodi:rx="1" sodipodi:ry="1" />
+  <path style="stroke:#000000" d="m 658.5,370.5 a 1,1 0 1 1 -2,0 1,1 0 1 1 2,0 z" sodipodi:type="arc" sodipodi:cx="658.5" sodipodi:cy="370.5" sodipodi:rx="1" sodipodi:ry="1" />
+</g>
 <g id="node-transform" inkscape:label="#g5821">
 <path sodipodi:nodetypes="ccccccccccc" id="path5786" d="m 480,55 0,5 1.5,-1.5 2,2 -1.5,1.5 5,0 0,-5 -1.5,1.5 -2,-2 1.5,-1.5 -5,0 z" style="fill:#000000;stroke:none;stroke-width:0.15833369999999999;stroke-miterlimit:4;stroke-opacity:1;stroke-dasharray:none" />
 <use height="540" width="1250" transform="matrix(-1,0,0,1,976,0)" id="use5795" xlink:href="#path5786" y="0" x="0" />

=== modified file 'src/widgets/connector-toolbar.cpp'
--- src/widgets/connector-toolbar.cpp	2013-08-29 21:42:16 +0000
+++ src/widgets/connector-toolbar.cpp	2013-09-07 17:18:00 +0000
@@ -397,7 +397,7 @@
                                     _(i->label),
                                     _(i->tooltip),
                                     INKSCAPE_ICON(i->icon),
-                                    Inkscape::ICON_SIZE_DECORATION);
+                                    secondarySize);
         gtk_action_group_add_action(mainActions, GTK_ACTION(act));
         gtk_toggle_action_set_active(GTK_TOGGLE_ACTION(act), !pref.compare(i->routing_type));
         g_object_set_data( holder, i->routing_type, act );