=== modified file 'src/widgets/fill-style.cpp'
--- src/widgets/fill-style.cpp	2013-07-18 14:29:45 +0000
+++ src/widgets/fill-style.cpp	2013-07-18 16:38:33 +0000
@@ -505,6 +505,10 @@
     Inkscape::Selection *selection = sp_desktop_selection(desktop);
 
     GSList const *items = selection->itemList();
+	
+	/* if( psel->isWheel() ) */
+			g_printf( "\n\n\n _-_-_- Wheel hai bc wheel=%d ! _- _- _ \n\n\n", psel->isWheel() );
+
 
     switch (psel->mode) {
         case SPPaintSelector::MODE_EMPTY:
@@ -545,7 +549,7 @@
                                 (kind == FILL) ? "fill-opacity" : "stroke-opacity" );
             DocumentUndo::maybeDone(sp_desktop_document(desktop), (kind == FILL) ? undo_F_label : undo_S_label, SP_VERB_DIALOG_FILL_STROKE,
                                     (kind == FILL) ? _("Set fill color") : _("Set stroke color"));
-
+			
             if (kind == FILL) {
                 // resume interruptibility
                 sp_desktop_canvas(desktop)->endForcedFullRedraws();

=== modified file 'src/widgets/paint-selector.cpp'
--- src/widgets/paint-selector.cpp	2013-06-06 13:44:11 +0000
+++ src/widgets/paint-selector.cpp	2013-07-18 16:58:11 +0000
@@ -434,6 +434,13 @@
     }
 }
 
+gboolean SPPaintSelector::isWheel()
+{
+	SPColorSelector *csel;
+	csel = reinterpret_cast<SPColorSelector*>(g_object_get_data(G_OBJECT(selector), "color-selector"));
+	return (csel->base->get_isWheel ( ) );
+}
+
 void SPPaintSelector::setFillrule(FillRule fillrule)
 {
     if (fillrulebox) {
@@ -469,6 +476,7 @@
     csel = reinterpret_cast<SPColorSelector*>(g_object_get_data(G_OBJECT(selector), "color-selector"));
     //rgba = color.toRGBA32( alpha );
     csel->base->setColorAlpha( color, alpha );
+	
 }
 
 void SPPaintSelector::setSwatch(SPGradient *vector )
@@ -659,6 +667,7 @@
     if ((psel->mode == SPPaintSelector::MODE_COLOR_RGB) || (psel->mode == SPPaintSelector::MODE_COLOR_CMYK)) {
         /* Already have color selector */
         csel = GTK_WIDGET(g_object_get_data(G_OBJECT(psel->selector), "color-selector"));
+		
     } else {
 
         sp_paint_selector_clear_frame(psel);

=== modified file 'src/widgets/paint-selector.h'
--- src/widgets/paint-selector.h	2013-03-15 01:08:49 +0000
+++ src/widgets/paint-selector.h	2013-07-18 15:43:55 +0000
@@ -79,6 +79,7 @@
 
 
     static Mode getModeForStyle(SPStyle const & style, FillOrStroke kind);
+	gboolean isWheel() ;
 
     void setMode( Mode mode );
     void setFillrule( FillRule fillrule );

=== modified file 'src/widgets/sp-color-selector.cpp'
--- src/widgets/sp-color-selector.cpp	2013-06-30 14:46:24 +0000
+++ src/widgets/sp-color-selector.cpp	2013-07-18 15:39:15 +0000
@@ -169,6 +169,7 @@
       _alpha(1.0),
       _brightness(1.0), //-- added for the additional brightness value
       _held(FALSE),
+	  _isWheel(FALSE),
       virgin(true)
 {
     g_return_if_fail( SP_IS_COLOR_SELECTOR(_csel) );

=== modified file 'src/widgets/sp-color-selector.h'
--- src/widgets/sp-color-selector.h	2013-06-30 14:46:24 +0000
+++ src/widgets/sp-color-selector.h	2013-07-18 16:12:54 +0000
@@ -25,6 +25,9 @@
 
     void setColorAlpha( const SPColor& color, gfloat alpha, bool emit = false );
     void getColorAlpha( SPColor &color, gfloat &alpha ) const;
+	
+	void set_isWheel() { _isWheel = TRUE;  }
+	gboolean get_isWheel() {return _isWheel ; }
 
     virtual void setSubmode( guint submode );
     virtual guint getSubmode() const;
@@ -37,7 +40,7 @@
     void _updateBrightness( const SPColor& color, gfloat bright, gboolean held );
     //--
     gboolean _isHeld() const { return _held; }
-
+	
     virtual void _colorChanged();
 
     static double _epsilon;
@@ -53,6 +56,7 @@
     ColorSelector& operator=( const ColorSelector& obj );
 
     gboolean _held;
+	gboolean _isWheel; // for checking if the colorselector is the wheel.
 
     bool virgin; // if true, no color is set yet
 };

=== modified file 'src/widgets/sp-color-wheel-selector.cpp'
--- src/widgets/sp-color-wheel-selector.cpp	2013-06-30 14:46:24 +0000
+++ src/widgets/sp-color-wheel-selector.cpp	2013-07-18 16:50:08 +0000
@@ -72,6 +72,7 @@
 
     widget_class->show_all = sp_color_wheel_selector_show_all;
     widget_class->hide = sp_color_wheel_selector_hide;
+	
 }
 
 ColorWheelSelector::ColorWheelSelector( SPColorSelector* csel )
@@ -88,6 +89,7 @@
       _label(0),
       _labelB(0)
 {
+	
 }
 
 ColorWheelSelector::~ColorWheelSelector()
@@ -107,17 +109,20 @@
 
     if ( SP_COLOR_SELECTOR(cs)->base )
     {
-        SP_COLOR_SELECTOR(cs)->base->init();
+        
+		SP_COLOR_SELECTOR(cs)->base->init();
+		SP_COLOR_SELECTOR(cs)->base->set_isWheel();	
     }
 }
 
 void ColorWheelSelector::init()
 {
     gint row = 0;
-
-    _updating = FALSE;
+	
+	_updating = FALSE;
     _dragging = FALSE;
-
+	
+	
 #if GTK_CHECK_VERSION(3,0,0)
     GtkWidget *t = gtk_grid_new();
 #else

=== modified file 'src/widgets/sp-color-wheel-selector.h'
--- src/widgets/sp-color-wheel-selector.h	2013-06-20 16:37:06 +0000
+++ src/widgets/sp-color-wheel-selector.h	2013-07-18 16:12:12 +0000
@@ -8,6 +8,10 @@
 #include "sp-color-slider.h"
 #include "sp-color-selector.h"
 
+// --
+#include <glib/gprintf.h>
+// --
+
 
 
 typedef struct _GimpColorWheel GimpColorWheel;